/* show_controllers.c
 * show the RSM controllers connected to this node */

#include <rsmapi.h>
#include <stdio.h>
#include <errno.h>



void main (int argc, char **argv)
  {
  int					status, i ;
  rsm_topology_t 	*rsmTopology ;
  uint_t				numControllers ;

  status = rsm_get_interconnect_topology(&rsmTopology);
  if ( status )
    {
    perror("error trying to get topology");
    exit(1);
    }


  /* how many controllers do we have ? */
  numControllers = rsmTopology->topology_hdr.local_cntlr_count ;
  printf("We have %d controllers\n", numControllers);

  if ( ! numControllers )
    { exit(0) ; }
  
  /* what are their names ? */
  for ( i= 0 ; i < (int)numControllers ; i++)
    {
    printf("controller #%d is called %s\n",
				(i + 1),
            rsmTopology->connections[i]->hdr.cntlr_name );
    }
  }
