/* show_topology.c
 * show the RSM topology connected to this node */

#include <rsmapi.h>
#include <stdio.h>
#include <errno.h>



void main (int argc, char **argv)
  {
  int					status, localCtl , remoteCtl;
  rsm_topology_t 	*rsmTopology ;
  uint_t				numCtls , numRemoteCtls;

  status = rsm_get_interconnect_topology(&rsmTopology);
  if ( status )
    {
    perror("error trying to get topology");
    exit(1);
    }


  /* how many controllers do we have ? */
  numCtls = rsmTopology->topology_hdr.local_cntlr_count ;
  printf("We have %d controllers\n", numCtls);

  if ( ! numCtls )
    { exit(0) ; }
  
  /* show controller connections */
  for ( localCtl= 0 ; localCtl < (int)numCtls ; localCtl++)
    {
    if ( numRemoteCtls 
             = rsmTopology->connections[localCtl]->hdr.remote_cntlr_count)
      {
      for (remoteCtl = 0 ; remoteCtl < numRemoteCtls ; remoteCtl++)
        {
        printf("%d:%s  ->  %d:%s  =  %d\n",
  rsmTopology->topology_hdr.local_nodeid,
  rsmTopology->connections[localCtl]->hdr.cntlr_name,
  rsmTopology->connections[localCtl]->remote_cntlr[remoteCtl].remote_nodeid,
  rsmTopology->connections[localCtl]->remote_cntlr[remoteCtl].remote_cntlrname,
  rsmTopology->connections[localCtl]->remote_cntlr[remoteCtl].connection_state);
        }
      }
    else
      {
      printf("No connections to %s\n",
              rsmTopology->connections[localCtl]->hdr.cntlr_name);
      }

    }


  }
