#include <strings.h>
#include <stdio.h>
#include <stdlib.h>
#include <scha.h>

main()
{
scha_err_t              err;
scha_resource_t         handle;
scha_status_value_t    *r_status;
scha_rsstate_t         *r_state;
char                   *str;
char                   *rgname = "foobar-rg";
char                   *rname = "foo-r";

err = scha_resource_open(rname, rgname, &handle);
if (err != SCHA_ERR_NOERR) {
	fprintf(stderr, "FAILED: scha_resource_open() %s\n", scha_strerror(err));
	exit(err);
}

err = scha_resource_get(handle, SCHA_STATUS, &r_status);
if (err != SCHA_ERR_NOERR) {
	fprintf(stderr, "FAILED: scha_resource_get() %s\n", scha_strerror(err));
	err = scha_resource_close(handle); // Close the handle.
	exit(err);
}

printf("SCHA_STATUS: %d\n", r_status -> status);
if(r_status -> status_msg != NULL) printf("Msg: %s\n", r_status -> status_msg);

err = scha_resource_get(handle, SCHA_RESOURCE_STATE, &r_state);
if (err != SCHA_ERR_NOERR) {
	fprintf(stderr, "FAILED: scha_resource_get() %s\n", scha_strerror(err));
	err = scha_resource_close(handle); // Close the handle.
	exit(err);
}

printf("SCHA_RESOURCE_STATE:  %d\n", r_state);

if(r_status -> status == SCHA_RSSTATUS_OK){ 	// Change status 
	printf("Changing status.\n");
	err = scha_resource_setstatus(rname, rgname,
           SCHA_RSSTATUS_OFFLINE, "Out to Lunch");
	if (err != SCHA_ERR_NOERR) {
		fprintf(stderr, "FAILED: scha_resource_setstatus() %s\n", scha_strerror(err));
		err = scha_resource_close(handle); // Close handle.
		exit(err);
	}
}

err = scha_resource_get(handle, SCHA_RESOURCE_STATE, &r_state);
if (err != SCHA_ERR_NOERR) {
	fprintf(stderr, "FAILED: scha_resource_get() %s\n", scha_strerror(err));
	err = scha_resource_close(handle); // Close the handle.
	exit(err);
}

printf("SCHA_RESOURCE_STATE: %d\n", r_state);

err = scha_resource_get(handle, SCHA_STATUS, &r_status);
if (err != SCHA_ERR_NOERR) {
	fprintf(stderr, "FAILED: scha_resource_get() %s\n", scha_strerror(err));
	err = scha_resource_close(handle); // Close handle.
	exit(err);
}

printf("SCHA_STATUS: %d\n", r_status -> status);
if(r_status -> status_msg != NULL) printf("Msg: %s\n", r_status -> status_msg);

err = scha_resource_close(handle); // Close the handle,
if (err != SCHA_ERR_NOERR) {
	fprintf(stderr, "FAILED: scha_resource_get() %s\n", scha_strerror(err));
	exit(err);
}
}
