/* Sun Cluster Data Services Builder template version 1.0 */
/*
 * cups_monitor_start.c - Start method for cups
 */

#include <rgm/libdsdev.h>
#include <scha.h>

int
main(int argc, char *argv[])
{

scds_handle_t	scds_handle;
scha_err_t err_code;
scds_pmf_status_t pmf_status;
int instance=0;
int child=0;

/* Process the arguments passed by RGM and initalize syslog */
if (scds_initialize(&scds_handle, argc, argv) != SCHA_ERR_NOERR) {
	scds_syslog(LOG_ERR, "Data Service handle failed to initialize!");
	return (1);
}

err_code = scds_pmf_start(scds_handle,SCDS_PMF_TYPE_MON,instance,"cups_probe", child);
if( err_code != SCHA_ERR_NOERR ){
        scds_syslog(LOG_ERR,"Monitor Failed to Start! Error: %s",scha_strerror(err_code));
        scds_close(&scds_handle);
        return(err_code);
}

err_code = scds_pmf_get_status(scds_handle,SCDS_PMF_TYPE_MON,instance, &pmf_status);
if( err_code != SCHA_ERR_NOERR ){
        scds_syslog(LOG_ERR,"Failed to get Monitor Status! Error: %s",scha_strerror(err_code));
        scds_close(&scds_handle);
        return(err_code);
}
if(pmf_status != SCDS_PMF_MONITORED ){
	scds_syslog(LOG_ERR,"Service is not monitored.");
	scds_close(&scds_handle);
	return(SCDS_PMF_NOT_MONITORED);
}


scds_syslog(LOG_NOTICE,"Cups Fault Monitor has started.");

/* Free up all the memory allocated by scds_initialize */
scds_close(&scds_handle);

/* Return the result of monitor_start method */
return (0);
}
